%function [wx,wy] = telesto_pol(th,ph)
%
%Copyright (C) 2018 Peter Munro
%
%This program is free software: you can redistribute it and/or modify
%it under the terms of the GNU Lesser Public License as published by
%the Free Software Foundation, either version 3 of the License, or
%(at your option) any later version.
%
%This program is distributed in the hope that it will be useful,
%but WITHOUT ANY WARRANTY; without even the implied warranty of
%MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%GNU Lesser Public License for more details.
%    
%You should have received a copy of the GNU Lesser Public License
%along with this program.  If not, see <http://www.gnu.org/licenses/>.
function [wx,wy] = telesto_pol(th,ph)
    
    NA_obj = 3.5/36;
    MFD = 9.2e-6;
    lambda = 1300e-9;
    F = pi*NA_obj*(MFD/2)*36/25/lambda;

    wx = exp(-(F*sin(th)/NA_obj).^2);
    wy = zeros(size(th));
