%Copyright (C) 2018 Peter Munro
%
%This program is free software: you can redistribute it and/or modify
%it under the terms of the GNU Lesser Public License as published by
%the Free Software Foundation, either version 3 of the License, or
%(at your option) any later version.
%
%This program is distributed in the hope that it will be useful,
%but WITHOUT ANY WARRANTY; without even the implied warranty of
%MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%GNU Lesser Public License for more details.
%    
%You should have received a copy of the GNU Lesser Public License
%along with this program.  If not, see <http://www.gnu.org/licenses/>.

nvec = [1. 1.54 1.33 1.33];
dz = -32.5e-6;
hvec = [-170e-6 0 50e-6]+dz;
lambda = 488e-9;
NA = 0.9;F = 1;
C = [230.4931  281.2254   64.5252   16.7386    4.7714    1.4552];
fringe_vec = [1 4 9 16 25 36];


addpath('/home/pmunro/UCL/research/coded_apertures/programs/angular_spec');
[theta_vec,wtheta_vec] = cons_gauleg(0,asin(NA/nvec(1)),1001);
rho = sin(theta_vec)/NA;

PHI1 = exp(sqrt(-1)*nvec(1)*2*pi/lambda*cos(theta_vec)*hvec(1));
PHI2 = ones(size(theta_vec));
Nterms=4; 
fringe_vec = [1 4 9 16 25 36];
PSI = zeros(size(theta_vec));
for i=1:Nterms
    PSI = PSI + C(i)*zernike_fringe_polyval(rho,fringe_vec(i));
end
PHI2 = exp(-sqrt(-1)*PSI);

PHI3 = ones(size(theta_vec));
PHI4 = ones(size(theta_vec));

addpath('/home/pmunro/code/focussed_multilayer');
for i=1:numel(theta_vec)
    [ST0] = multi_layer( hvec, nvec, lambda, theta_vec(i), 'TE');
    PHI3(i) = exp(sqrt(-1)*angle(1/ST0(1,1)));
    [ST1] = multi_layer( [hvec(1) 0], [1 1 1], lambda, theta_vec(i), 'TE');
    PHI4(i) = exp(sqrt(-1)*angle(1/ST1(1,1)));
end
rmpath('/home/pmunro/code/focussed_multilayer');
%NOTE: PHI1 = conj(PHI4);
Wresid = unwrap(angle(PHI1.*PHI3.*PHI2));

save aber_resid Wresid rho;

%Code below this line is not required
theta_vec_2 = asin(sin(theta_vec)/1.33);
PHI5 = exp(sqrt(-1)*2*pi/lambda*(nvec(1)*hvec(1)*cos(theta_vec) - nvec(end)*hvec(1)*cos(theta_vec_2)));
