%Evaluates the nth order Zernike fringe polynomial for normalised
%pupil coordinate rho.
%
%n is assumed to begin at n=1
%Copyright (C) 2018 Peter Munro
%
%This program is free software: you can redistribute it and/or modify
%it under the terms of the GNU Lesser Public License as published by
%the Free Software Foundation, either version 3 of the License, or
%(at your option) any later version.
%
%This program is distributed in the hope that it will be useful,
%but WITHOUT ANY WARRANTY; without even the implied warranty of
%MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%GNU Lesser Public License for more details.
%    
%You should have received a copy of the GNU Lesser Public License
%along with this program.  If not, see <http://www.gnu.org/licenses/>.
function [z] = zernike_fringe_polyval(rho,n)

zfpcoeffs = {{1.},
{0., 1.},
{0., 1.},
{-1., 0., 2.},
{0., 0., 1.},
{0., 0., 1.},
{0., -2., 0., 3.},
{0., -2., 0., 3.},
{1., 0., -6., 0., 6.},
{0., 0., 0., 1.},
{0., 0., 0., 1.},
{0., 0., -3., 0., 4.},
{0., 0., -3., 0., 4.},
{0., 3., 0., -12., 0., 10.},
{0., 3., 0., -12., 0., 10.},
{-1., 0., 12., 0., -30., 0., 20.},
{0., 0., 0., 0., 1.},
{0., 0., 0., 0., 1.},
{0., 0., 0., -4., 0., 5.},
{0., 0., 0., -4., 0., 5.},
{0., 0., 6., 0., -20., 0., 15.},
{0., 0., 6., 0., -20., 0., 15.},
{0., -4., 0., 30., 0., -60., 0., 35.},
{0., -4., 0., 30., 0., -60., 0., 35.},
{1., 0., -20., 0., 90., 0., -140., 0., 70.},
{0., 0., 0., 0., 0., 1.},
{0., 0., 0., 0., 0., 1.},
{0., 0., 0., 0., -5., 0., 6.},
{0., 0., 0., 0., -5., 0., 6.},
{0., 0., 0., 10., 0., -30., 0., 21.},
{0., 0., 0., 10., 0., -30., 0., 21.},
{0., 0., -10., 0., 60., 0., -105., 0., 56.},
{0., 0., -10., 0., 60., 0., -105., 0., 56.},
{0., 5., 0., -60., 0., 210., 0., -280., 0., 126.},
{0., 5., 0., -60., 0., 210., 0., -280., 0., 126.},
{-1., 0., 30., 0., -210., 0., 560., 0., -630., 0., 252.},
{1., 0., -42., 0., 420., 0., -1680., 0., 3150., 0., -2772., 0., 924.}};

z = polyval(fliplr([zfpcoeffs{n}{:}]),rho);
